//////////////////////////////////////////////////////////////////////////////////////////
///
/// Global Vars
///
//////////////////////////////////////////////////////////////////////////////////////////

var pageData='';
var gasSiteURL='';
var areas='';
var intersections='';
var stations='';
var imgs='';
var tempSite='';
var pageCount = '';
var currentPage=1;
var itemIndices =  null;
var routeIndex = null;
var isDataLoaded = false;

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// loadMain - first method called when gadget loads/reloads
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function loadMain() {   
    // main gadget onload method (first method called every time the gadget is loaded/reloaded)
   
    // init dock/undock event methods
    System.Gadget.onDock = onDockEvent;                                   // set gadget ondock method    
    System.Gadget.onUndock = onUndockEvent;                               // set gadget onundock method
  
    // init flyout file
    System.Gadget.Flyout.file = "flyout.htm";                               // set flyout page
    System.Gadget.Flyout.onHide = hideFlyout;
    
    // init settings event methods and data
    System.Gadget.settingsUI = "settings.htm";                              // set settings page
    System.Gadget.onShowSettings = openSettingsEvent;
    System.Gadget.onSettingsClosed = closeSettingsEvent;               // set settings onclosed method

	//gasSiteURL = System.Gadget.Settings.read("gasSiteEnv");
	
	gadgetNoSettings.style.display="block";
	gadgetGasData.style.display="none";
	
	if(gasSiteURL != null && gasSiteURL !=''){
	//	gadgetNoSettings.style.display="none";
	//	gadgetGasData.style.display="block";
		loadGasData();	
	}
	else{
	//	gadgetNoSettings.style.display="block";
	//	gadgetGasData.style.display="none";
	}
	
    // init gadget config and layout
    if (System.Gadget.docked) {
        // process docked gadget init
        docked();
    }
    else {
        // process undocked gadget init
        undocked();
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////
////
///
//
//
////////////////////
function hideFlyout(){
    //System.Gadget.document.getElementById('dockedFlyoutButtonImg').style.backgroundImage='url(images/aDocked.png)';
  //  if(mapPlaces.toString() != System.Gadget.Flyout.document.parentWindow.mapPlaces.toString() || mapPlaces.length != System.Gadget.Flyout.document.parentWindow.mapPlaces.length || mapPlaces[currentStation-1] == null || mapPlaces[currentStation-1] == ''){
    //    gadgetGasData.innerHTML = mapPlaces[currentStation];
        mapPlaces = System.Gadget.Flyout.document.parentWindow.mapPlaces;
        
        map.LoadMap(new VELatLong(homeLatLong.Latitude,homeLatLong.Longitude),10,mapMode,false);
        initMap();
        isNewMap();
        if(newMap)
            populate();
        else
            populateExisting();
    //}
}

function setFlyoutButton(x){
    if (x == 'out' && !System.Gadget.Flyout.show)
        System.Gadget.document.getElementById('dockedFlyoutButtonImg').style.backgroundImage='url(images/aDocked.png)';
    else if (x == 'out' && System.Gadget.Flyout.show)
        System.Gadget.document.getElementById('dockedFlyoutButtonImg').style.backgroundImage='url(images/aDocked-Clicked.png)';    
    else if (x == 'over')
        System.Gadget.document.getElementById('dockedFlyoutButtonImg').style.backgroundImage='url(images/aDocked-Hover.png)';
    else if (x == 'down' && !System.Gadget.Flyout.show)
        System.Gadget.document.getElementById('dockedFlyoutButtonImg').style.backgroundImage='url(images/aDocked-Clicked.png)';
    else if (x == 'down' && System.Gadget.Flyout.show)
        System.Gadget.document.getElementById('dockedFlyoutButtonImg').style.backgroundImage='url(images/aDocked-Hover.png)';
    else if (x == 'up' && !System.Gadget.Flyout.show)
        System.Gadget.document.getElementById('dockedFlyoutButtonImg').style.backgroundImage='url(images/aDocked-Hover.png)';
    else if (x == 'up' && System.Gadget.Flyout.show)
        System.Gadget.document.getElementById('dockedFlyoutButtonImg').style.backgroundImage='url(images/aDocked-Clicked.png)';
} 
        
        
    

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// procSettingsClosedEvent - process settings closed event
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function closeSettingsEvent	(event){
    // process settings closed event
    
   if (event.closeAction == event.Action.commit) {
   
	   gasSiteURL = System.Gadget.Settings.read("gasSiteEnv");
   	//	gadgetNoSettings.style.display="none";
	//	gadgetGasData.style.display="block";
	  if(gasSiteURL != null && gasSiteURL != '')
	   loadGasData();
	   
	   
   }
}
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// openSettingsEvent - process settings opened event
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function openSettingsEvent(){
    // process settings closed event
    
   		gadgetNoSettings.style.display="block";
		gadgetGasData.style.display="none";
	//	gadgetNoSettings.innerHTML="<div style='text-align:center;font-size:12px;color:white'>Loading...<br><img src ='images/loading.gif'></div>";
}
///////////////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////////////
//
// procDockEvent - process dock event
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function onDockEvent()
{   // process dock event
    docked();
}
///////////////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////////////
//
// procUndockEvent - process undock event
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function onUndockEvent()
{   // process undock event
    undocked();
}
///////////////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////////////
//
// genDocked - gen docked gadget layout
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function docked()
{   // gen docked gadget layout
    
    // set gadget document styles
    document.body.style.width = "130px";                                            // set total gadget width
    document.body.style.height = "190px";                                           // set total gadget height
    System.Gadget.background="url(images/Main-NoButtons2.png)";                     // set gadget background image
    // * NOTE - the above gadget document width and height settings should be set 
    //          to the same dimensions as the size of the above background image.

    
    // set gadget content visibility
    dataCell.style.display = "block";                               // display docked content
    undockedCell.style.display = "none";                              // hide undocked content        
    dockedFlyoutButtonImg.style.display="block";
    dockedFlyoutButton.style.display="block";
    setBottomButtons();
    // add settings data to page
    
  	//gadgetGasDataDocked.innerHTML = gasSiteURL;
}
///////////////////////////////////////////////////////////////////////////////////////////////////



///////////////////////////////////////////////////////////////////////////////////////////////////
//
// genUndocked - gen undocked gadget layout
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function undocked()
{   // gen undocked gadget layout
    
    // set gadget document styles
    document.body.style.width = "407px";                                            // set total gadget width
    document.body.style.height = "190px";                                           // set total gadget height
    System.Gadget.background="url(images/Undock3.png)";                     // set gadget background image
    
    // * NOTE - the above gadget document width and height settings should be set 
    //          to the same dimensions as the size of the above background image.

    // set main gadget frame styles (main gadget area minus above background frame)
                                            // set main frame height
    
    // set content frame styles (main gadget content area)
//    gadgetGasDataUndocked.style.width = "117px";                                       // set content frame width
//    gadgetGasDataUndocked.style.height = "148px";                                      // set content frame height
    
//    gasMap.style.width = "300px";                                          // set main frame width
//    gasMap.style.height = "220px"; 
    
    // set gadget content visibility
    dataCell.style.display = "block";                                // hide docked content
    undockedCell.style.display = "block";                             // display undocked content        
    dockedFlyoutButtonImg.style.display="none";
    dockedFlyoutButton.style.display="none";
    setBottomButtons();
    // add settings data to page
    //gadgetGasDataUndocked.innerHTML = "theSettingsData";   // add settings data to gadget
    if (dataLoaded()  && isLoaded)
        moveMap();
}
///////////////////////////////////////////////////////////////////////////////////////////////////

/////////////////////////////
///
/// setPageCount - sets the number of pages in current data
///
////////////////////////////
function setPageCount(){
	pageCount = imgs.length / 4;
	pageCount = Math.round(pageCount);
	
	if (currentPage > 9)
		gasPageNumber.innerText=currentPage+"/"+pageCount;
	else if (pageCount > 9)
		gasPageNumber.innerText = "0"+currentPage+"/"+pageCount;
	else gasPageNumber.innerText = "0"+currentPage+"/0"+pageCount;
}


/////////////////////////////////////////////////////////////////////////////////
///
/// nextPage - set next page of data
///
/////////////////////////////////////////////////////////////////////////////
function nextPage(){
	if(currentPage < pageCount){
	    currentPage = currentPage+1;
	    setPageCount();
	    setItems();
	}
	else {
	    currentPage = 1;
	    setPageCount();
	    setItems();
	}
	
	if (System.Gadget.Flyout.show)
        System.Gadget.Flyout.document.parentWindow.setCurrentPins(currentPage);
    else
        System.Gadget.document.parentWindow.setCurrentPins(currentPage);
	
}

/////////////////////////////////////////////////////////////////////////////////
///
/// prevPage - set previous page of data
///
/////////////////////////////////////////////////////////////////////////////
function prevPage(){
	if(currentPage>1){
	    currentPage=currentPage-1;
    	setPageCount();
	    setItems();
	}
	else {
	    currentPage=pageCount;
	    setPageCount();
	    setItems();
	}
	
	if (System.Gadget.Flyout.show)
	    System.Gadget.Flyout.document.parentWindow.setCurrentPins(currentPage);
	else
	    System.Gadget.document.parentWindow.setCurrentPins(currentPage);
	    
}

//////////////////////////////////////////////////////
///
/// getCurrentPage() - return current page#
///
//////////////////////////////////////////////////
function getCurrentPage(){
	return currentPage;
}


//////////////////////////////////////////////////////////////////////////////////////////
///
/// setItems - sets the items currently displayed
///
//////////////////////////////////////////////////////////////////////////////////////
function setItems(){
    if((currentPage*4)-4<imgs.length){
	    item1.innerHTML = "<img src=\""+tempSite+"/"+imgs[(currentPage*4)-4]+"\">&emsp;-&emsp;"+stations[(currentPage*4)-4]+"<br/>"+intersections[(currentPage*4)-4];//"<table style='color:white; font-size:10px;'><tr><td style='text-align:center'><img src=\""+tempSite+"/"+imgs[(currentPage*4)-4]+"\"></td><td>"+stations[(currentPage*4)-4]+"</td></tr><tr><td>"+areas[(currentPage*4)-4]+"</td><td>"+intersections[(currentPage*4)-4]+"</td></tr></table>";
	    item1.title=intersections[(currentPage*4)-4] +" - "+areas[(currentPage*4)-4];
    }
	else{
	    item1.innerHTML = "";
	    item1.title="";
	}
	if((currentPage*4)-3<imgs.length){
	    item2.innerHTML = "<img src=\""+tempSite+"/"+imgs[(currentPage*4)-3]+"\">&emsp;-&emsp;"+stations[(currentPage*4)-3]+"<br/>"+intersections[(currentPage*4)-3];
        item2.title=intersections[(currentPage*4)-3] +" - "+areas[(currentPage*4)-3];
    }
	else{
	    item2.innerHTML = "";
	    item2.title="";
    }	
	if((currentPage*4)-2<imgs.length){
	    item3.innerHTML = "<img src=\""+tempSite+"/"+imgs[(currentPage*4)-2]+"\">&emsp;-&emsp;"+stations[(currentPage*4)-2]+"<br/>"+intersections[(currentPage*4)-2];
	    item3.title=intersections[(currentPage*4)-2] +" - "+areas[(currentPage*4)-2];
    }
	else{
	    item3.innerHTML = "";
	    item3.title="";
    }
	if((currentPage*4)-1<imgs.length){
	    item4.innerHTML = "<img src=\""+tempSite+"/"+imgs[(currentPage*4)-1]+"\">&emsp;-&emsp;"+stations[(currentPage*4)-1]+"<br/>"+intersections[(currentPage*4)-1];
	    item4.title=intersections[(currentPage*4)-1] +" - "+areas[(currentPage*4)-1];
    }
	else{
	    item4.innerHTML = "";
	    item4.title="";
    }

    item1.noWrap=true;
    item2.noWrap=true;
    item3.noWrap=true;
    item4.noWrap=true;	
	itemIndices = new Array((currentPage*4)-4,(currentPage*4)-3,(currentPage*4)-2,(currentPage*4)-1);
	
	System.Gadget.document.getElementById('gadgetNoSettings').style.display="none";
	System.Gadget.document.getElementById('gadgetGasData').style.display="block";
    
}

//////////////////////////////////////////////////////////
///
/// setTempsite() - sets temp site
///
////////////////////////////////////////////////////////////
function setTempsite(){
	tempSite = System.Gadget.Settings.read("tempGasSiteEnv");
}


///////////////////////////////////////////////////////////////////////////////////////////
///
/// loadGasData - Obtains the page data containing the gas prices as set in settings
///
//////////////////////////////////////////////////////////////////////////////////////////
function loadGasData(){
	if (gasSiteURL == null || gasSiteURL == ''){
	}
	else{
	    pageData='';
	    stations='';
	    intersections='';
	    areas='';
	    imgs='';
		retrievePageData(gasSiteURL);
		parseGasData();
	}
}

//////////////////////////////////////////////////////////////////////////////
///
/// parseCityData - Parses the page source to obtain the cities that are searchable and loads the select tag
///
//////////////////////////////////////////////////////////////////////////////////////
function parseGasData(){
	if(pageData=='' || pageData == null){
		setTimeout("parseGasData()",250);
	}
	else{
		var regEx = new RegExp("<tr class='PTableRow'>[\\s\\w<>=\"'.?/&:()\-_;]*?<tr class='PTableRow'>[\\s\\w<>=\"'.?/&:()\-_;]*?</tr>","g");
		var imgRegEx = new RegExp("images/p/g/[a-fA-F0-9]*.[a-zA-Z]{3}","ig");
		var stationRegEx = new RegExp("PStation[^]*?<","i");
		var intersectionRegEx = new RegExp("PAddress[^]*?<","i");
		var areaRegEx = new RegExp("PList[^]*?<","i");
		
		var parsedPageData = pageData.match(regEx);		
		imgs = parsedPageData.toString().match(imgRegEx);
		//var intersections = parsedPageData.toString().match(intersectionRegEx);
		//var stations = parsedPageData.toString().match(stationRegEx);
		
		for(i=0; i<parsedPageData.length; i++){
			var match='';
			match = parsedPageData[i].match(stationRegEx).toString();
			stations += trim(match.substring(match.indexOf(">")+1, match.indexOf("<")))+ "";
			match = parsedPageData[i].match(intersectionRegEx).toString();
			intersections += trim(match.substring(match.indexOf(">")+1, match.indexOf("<"))).replace(/[(].*?[)]/g,"")+ "";
			match = parsedPageData[i].match(areaRegEx).toString();
			areas += match.substring(match.indexOf(">")+1,match.indexOf("<")) + "";
		}
		areas = areas.substring(0,areas.length-2).split('');
		stations = stations.substring(0,stations.length-2).split("");
		intersections = intersections.substring(0,intersections.length-2).split("");
		
		System.Gadget.Settings.write("stationsEnv",stations);
		System.Gadget.Settings.write("intersectionsEnv",intersections);
		System.Gadget.Settings.write("areasEnv",areas);
		System.Gadget.Settings.write("imgsEnv",imgs);
		
		pageData='';
		
	   setTempsite();
	   setPageCount();
	   setItems();
	   
	   createMap();
		
	}
}

//////////////////////////////////////////////////////////////////////////////////////
///
/// trim - trim whitespace from right and left sides
///
/////////////////////////////////////////////////////////////////////////////////////

function trim(stringToTrim) {
	return stringToTrim.replace(/^\s+|\s+$/g,"");
}
	

///////////////////////////////////////////////////////////////////////////////////////////
///
/// retrievePageData(url) - takes a URL to retrieve page data from and calls function to set hidden value to page data
///
//////////////////////////////////////////////////////////////////////////////////////////
function retrievePageData(url){
	var req = new ActiveXObject("Microsoft.XMLHTTP");
	if (req) {
		req.onreadystatechange = function(){
			if (req.readyState == 4) { // Complete
				if (req.status == 200) { // OK response
					pageData = req.responseText;
				}
			}
		}		
		req.open("GET", url, true);
		req.send();
	}
}
 
///////////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// processStateChange - when request receives OK resposne sets the hidden value to the acquired page data
///
///////////////////////////////////////////////////////////////////////////////////////////////////////////
function processStateChange() {
	if (req.readyState == 4) { // Complete
		if (req.status == 200) { // OK response
			pageData = req.responseText;
		}
	}
}

function createMap(){
    if(!dataLoaded()){
        setTimeout(createMap,250);
    }
    else{
        getMap('mapDiv');
    }
}

function setBottomButtons(){
    if(!System.Gadget.docked){
        leftB.style.left= "282px";  
        rightB.style.left="362px";
        gasPageNumber.style.left="310px";
    }else{
        leftB.style.left="4px";
        rightB.style.left="88px";
        gasPageNumber.style.left="32px";
    }
}

function flyoutControl(){
    if(dataLoaded() && System.Gadget.docked && !System.Gadget.Flyout.show){
        System.Gadget.Flyout.show=true;
    }
    else {
        System.Gadget.Flyout.show = false;
    }
}
    
    
function dataLoaded(){
    return(stations.length == intersections.length && intersections.length == areas.length 
                && stations != null && areas != null && intersections != null 
                && stations.length > 0 && areas.length > 0 && intersections.length > 0)
}

function findRoute(index){
    
    if (index == null || index.toString() == '') 
        index = routeIndex;
    else
        routeIndex = index;
    if (System.Gadget.Flyout.show){
        if (System.Gadget.Flyout.document.parentWindow.isLoaded)
            System.Gadget.Flyout.document.parentWindow.getRoute(routeIndex);
        else
            setTimeout(findRoute,250);
    }            
//    else if (!System.Gadget.Flyout.document.parentWindow.isLoaded)
//        setTimeout(findRoute,250);    
    else if (!System.Gadget.Flyout.show && System.Gadget.docked){
        System.Gadget.Flyout.show=true;
        setTimeout(findRoute,250);
    }
    else 
        System.Gadget.document.parentWindow.getRoute(routeIndex);
}

function disableButtons(){
    System.Gadget.document.getElementById('leftB').onclick = '';
    System.Gadget.document.getElementById('rightB').onclick = '';
    System.Gadget.document.getElementById('dockedFlyoutButton').onclick = '';
    System.Gadget.document.getElementById('item1').disabled = 'true';
    System.Gadget.document.getElementById('item2').disabled = 'true';
    System.Gadget.document.getElementById('item3').disabled = 'true';
    System.Gadget.document.getElementById('item4').disabled = 'true';
    
}

function enableButtons(){
    System.Gadget.document.getElementById('leftB').onclick = prevPage;
    System.Gadget.document.getElementById('rightB').onclick = nextPage;
    System.Gadget.document.getElementById('dockedFlyoutButton').onclick = flyoutControl;
    System.Gadget.document.getElementById('item1').disabled = ''
    System.Gadget.document.getElementById('item2').disabled = ''
    System.Gadget.document.getElementById('item3').disabled = ''
    System.Gadget.document.getElementById('item4').disabled = ''
    
}