﻿var map = null;
var icon ='';
var infobox = '';
var currentStation=0;
var currentStationMax=20;
var currentStationMin=0;
var mapPlaces = new Array();
var homeLatLong = null;     
var latLong=null;
var errorFound=false;
var errorCount=0;
//var layer=null;
var distUnits = null;
var mapDivElement = null;
var icons = new Array();
var descriptions = new Array();
var newMap = true;
var isLoaded = false;

var mapMode='';
var mapCenter='';
var mapPC='';
var mapAddr='';
var mapStateProv='';
var mapCity='';


var stations='';
var intersections='';
var imgs='';
var areas='';
var tempSite='';
var provstate='';   
var cityName='';
var country='us'
var newSettings='';


///////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////////////////////////////
      
function SetAutoLocateViewport(latitude, longitude, zoom, showSwitch, msg){
    latLong = new VELatLong(latitude,longitude);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function AutoLocateUndetectable(msg){
	if((msg!=null || msg != '') && mapCenter == 'wifiMapRadio')
		mapCenter = 'cityMapRadio';
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
  
function setInfobox(){
  	infobox="<div style='font-weight:bold; font-size:12px; text-align:center;'>"+stations[currentStation]+" - "+intersections[currentStation]+" - "+areas[currentStation]+"</div>";

    if(descriptions.length < currentStationMax)
        descriptions.length = currentStationMax;
        
    descriptions[currentStation] = infobox;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function setIcon(){
    var stationName = stations[currentStation].replace(/ /,'');
    stationName = stationName.replace(/-/,'');
    stationName = stationName.replace(/'/,'');
    stationName = stationName.replace(/\//,'');
    stationName = stationName.replace(/\\/,'');
    
    var stationMatchName = stationName.match(/shell|esso|exxonmobil|exxon|mobil|petrocanada|7eleven|76|amoco|ampm|bp|canadiantire|chevron|citgo|conocophilips|conoco|costco|diamondshamrock|flyingj|hess|husky|macs|marathon|murphyusa|petrocanada|phillips|phillips66|pioneer|sunoco|sunys|superamerica|texaco|total|ultramar|unocal|valero/i);
    
    if (stationMatchName != null){
        icon = stationMatchName+".png";
    }
    else
        icon = "generic.png";       
        
    if (icons.length < currentStationMax)
        icons.length = currentStationMax;
        
    icons[currentStation] = icon;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function initSettings(){
	stations = System.Gadget.document.parentWindow.stations;
	areas = System.Gadget.document.parentWindow.areas;
	imgs = System.Gadget.document.parentWindow.imgs;
	tempSite = System.Gadget.document.parentWindow.tempSite;
	intersections = System.Gadget.document.parentWindow.intersections;
	
	newSettings = System.Gadget.Settings.read("newSettingsEnv");
	
	mapMode = System.Gadget.Settings.read("mapModeEnv").charAt(0);
	mapCenter = System.Gadget.Settings.read("mapCenterEnv");
	
	provstate=System.Gadget.Settings.read("provstateEnv");
	cityName = System.Gadget.Settings.read("cityNameEnv");
	country = System.Gadget.Settings.read("countryEnv");
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function initMap(){
	//	scriptElem = document.createElement("script");
	//	scriptElem.src = "http://local.live.com/WiFiIPService/locate.ashx";
	//	head.appendChild(scriptElem);
	
    System.Gadget.document.parentWindow.disableButtons();
    
	
	if(newSettings == 'true'){
	    mapPlaces = new Array();
	    descriptions = new Array();
	    icons = new Array();
	    homeLatLong = '';
	    currentStation=0;
	    currentStationMax=20;
	    currentStationMin=0;
	    
	    if (country == 'canada')
	        distUnits = VEDistanceUnit.Kilometers;
	    else if (country == 'us')
	        distUnits = VEDistanceUnit.Miles;
	        
	        //gadgetGasData.innerHTML = country;
    	    	
	    if (mapCenter == 'locateMapRadio' && map != null){
		    map.LoadMap(latLong,10,mapMode,false);
	    }
	    else if (map!=null){
		    map.LoadMap(null,10,mapMode,false);
	    }
	}
	else {
//	    mapPlaces = System.Gadget.Settings.read("mapPlacesEnv").parseJSON();
//	    descriptions = System.Gadget.Settings.read("descriptionsEnv").parseJSON();
//	    icons = System.Gadget.Settings.read("iconsEnv").parseJSON();
//	    homeLatLong = System.Gadget.Settings.read("homeLatLongEnv").parseJSON();

        mapPlaces = System.Gadget.document.parentWindow.mapPlaces;
        descriptions = System.Gadget.document.parentWindow.descriptions;
        icons = System.Gadget.document.parentWindow.icons
        homeLatLong = System.Gadget.document.parentWindow.homeLatLong;
        distUnits = System.Gadget.document.parentWindow.distUnits;
        currentStationMax = System.Gadget.document.parentWindow.currentStationMax;
        currentStationMin = System.Gadget.document.parentWindow.currentStationMin;
        currentStation = System.Gadget.document.parentWindow.currentStationMin;
        
        
	    map.LoadMap(new VELatLong(homeLatLong.Latitude,homeLatLong.Longitude),10,mapMode,false);
	}
	        

	
	
	map.HideDashboard();
	map.ShowDisambiguationDialog(false);
	map.AttachEvent("onerror", hasError);
	
	//layer = new VEShapeLayer();
	//map.AddShapeLayer(layer);

}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function isNewMap(){
    if(mapPlaces != null && mapPlaces != '' && mapPlaces.length > 0 && mapPlaces.length>=currentStationMax && mapPlaces.length>currentStationMin
        && mapPlaces[currentStation]!=null && mapPlaces[currentStation] != '')
        newMap = false;
    else
        newMap = true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function populateExisting(){
    icon = icons[currentStation];
    
    infobox = descriptions[currentStation];
    setPin(null,null,mapPlaces[currentStation],null);
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function populate(){

//    if (homeLatLong == null)	
//	    addHome();
//	else {    

	    setInfobox();
	    setIcon();
	    var tempArea = areas[currentStation];
	    if (tempArea.indexOf(" - ") > 0)
	        tempArea = tempArea.substring(0,tempArea.indexOf(" - "));
	    
	    if (errorCount == 1  && cityName != provstate){
	        tempArea = cityName;
	    }
	    else if (errorCount == 2 || errorFound == true){
	        currentStation++;
	        errorCount = 0;
	        errorFound = false;
	        mapPlaces.push(null);
	    }
	    
	    map.Find(null,intersections[currentStation].replace(/&/g,escape('&'))+", "+tempArea+", "+provstate,null,null,null,null,false,false,false,false, setPin);
	
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function setPin(shape, results, places, hasmore){
    if (errorFound == false){

	    if(places != null){
	        var stationPin = '';
	        if(places == mapPlaces[currentStation]){
                stationPin = new VEShape(VEShapeType.Pushpin, places);
            }
	        else {
	            stationPin = new VEShape(VEShapeType.Pushpin, places[0].LatLong);
	            if(mapPlaces.length == currentStation)
	                mapPlaces.push(places[0].LatLong);
	            else if (mapPlaces.length < currentStationMax){
	                mapPlaces.length = currentStationMax;
	                mapPlaces[currentStation] = places[0].LatLong;
	            }
	            else
	                mapPlaces[currentStation] = places[0].LatLong;
	        }
	        //stationPin.SetCustomIcon("../images/"+icon);
	        stationPin.SetTitle("<h2 align='center'>Station #"+(currentStation+1)+"<br/>Price: <img src='"+tempSite+"/"+imgs[currentStation]+"'></h2>");
	        stationPin.SetDescription(infobox);
	        var spec = new VECustomIconSpecification();
	        spec.Image = "../images/"+icon;
        	
        	
	        stationPin.SetCustomIcon(spec);
	        map.AddShape(stationPin);
        	
	        
	        errorCount = 0;
        }	
	    currentStation++;
    }   	
    
    
    infobox='';
    icon='';
	
    if (currentStation < currentStationMax && currentStation >= currentStationMin)
    {
        if(newMap)
            populate();	
        else
            populateExisting();
    }
    else{
        formatMapPlaces();
        addHome();
    }
        
    
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////////////

function hasError(){
gadgetGasData.innerHTML = errorCount;
    
    errorCount++;   
    errorFound=true;
}

///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      
function setHome(shape, results, places, hasmore){
    var homePin=null;
    if (places == homeLatLong){
	   homePin = new VEShape(VEShapeType.Pushpin, homeLatLong);
       homePin.SetDescription(descriptions[descriptions.length-1]);
    }
    else {
        if (places == latLong)
            homeLatLong = latLong;
        else
	        homeLatLong = places[0].LatLong;
	
	    homePin = new VEShape(VEShapeType.Pushpin, homeLatLong);
	    homePin.SetTitle("<h2>You Are Here</h2>");
	    homePin.SetDescription("Home");
	}
	var spec = new VECustomIconSpecification();
	spec.Image = "../images/home.png";
	            
	homePin.SetCustomIcon(spec);
	map.AddShape(homePin);
	
	//if (stations.length > 0) 
	//    populate();
	finalize();
}   

///////////////////////////////////////////////////////////////////////////////////////////////////////

function addHome(){

    if(homeLatLong != null && homeLatLong != '')
        setHome(null,null,homeLatLong,null);
        
    if (latLong != null){
        map.SetCenterAndZoom(latLong, 10);
        setHome(null,null,latLong,null);
    }
    
    if (mapCenter == 'cityMapRadio'){
		tempGasSite = System.Gadget.Settings.read("tempGasSiteEnv");
		if(cityName.match(provstate,"i") != null)
		    map.Find(null,provstate,null,null,null,null,false,false,false,true, setHome);
		else
		    map.Find(null,cityName+", "+provstate,null,null,null,null,false,false,false,true, setHome);
	}
	else if (mapCenter == 'pcMapRadio'){
		mapPC = System.Gadget.Settings.read("mapPCEnv");
		map.Find(null,mapPC,null,null,null,null,false,false,false,true, setHome);
	}
	else if (mapCenter == 'addrMapRadio'){
		mapAddr = System.Gadget.Settings.read("mapAddrEnv");
		mapCity = System.Gadget.Settings.read("mapCityEnv");
		mapStateProv = System.Gadget.Settings.read("mapStateProvEnv");
		map.Find(null,mapAddr+", "+mapCity+", "+mapStateProv,null,null,null,null,false,false,false,true, setHome);
	}
}

///////////////////////////////////////////////////////////////////////////////////////////////////////
      
function getMap(id)
{         
    //if(System.Gadget.Flyout.show)
  //      mapDivElement = System.Gadget.Flyout.document.getElementById(id);
    //else
    if (mapDivElement == null || mapDivElement == '')
        mapDivElement = System.Gadget.document.getElementById(id);
    
    map = new VEMap(id);        
	
	initSettings();
	initMap();
	
	isNewMap();
	
    if(newMap)
        populate();	
    else
        populateExisting();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function getRoute(index){
    if(mapPlaces[index] != null && mapPlaces[index] != '')
        map.GetRoute(new VELatLong(homeLatLong.Latitude,homeLatLong.Longitude),new VELatLong(mapPlaces[index].Latitude,mapPlaces[index].Longitude),distUnits);
    else
    {
        
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function moveMap(){
    if (!System.Gadget.docked && System.Gadget.document.parentWindow.dataLoaded()){
        map.Resize(268,174);
        map.SetCenter(homeLatLong);
        undockedMapLoading.style.display = "none";
	    undockedMap.appendChild(mapDivElement);
	    
	}
	else if (!System.Gadget.docked)
	    setTimeout(moveMap,250);
	else if(System.Gadget.Flyout.show)
        System.Gadget.Flyout.document.getElementById('loadingDiv').style.display="none";
	    
	    
    System.Gadget.document.parentWindow.enableButtons();
	
}   

///////////////////////////////////////////////////////////////////////////////////////////////////////

function finalize(){
    System.Gadget.Settings.write("mapPlacesEnv", mapPlaces.toJSONString());
    System.Gadget.Settings.write("homeLatLongEnv", homeLatLong.toJSONString());
    System.Gadget.Settings.write("iconsEnv", icons.toJSONString());
    System.Gadget.Settings.write("descriptionsEnv", descriptions.toJSONString());
    newSettings = 'false';  
    isLoaded=true;
    System.Gadget.Settings.write("newSettingsEnv",newSettings);
    moveMap();
}

///////////////////////////////////////////////////////////////////////////////////////////////////////

function setCurrentPins(page){
    
            
    var tempMax = Math.ceil(page * 4 / 20) * 20;
        
    if(tempMax > currentStationMax || tempMax < currentStation || tempMax < currentStationMin){

        if (System.Gadget.Flyout.show){
        
            System.Gadget.Flyout.document.getElementById('loadingDiv').style.display="block";
            System.Gadget.Flyout.document.getElementById('loadingDiv').innerHTML="<div style='top:200px; text-align:center; color:white; position:relative'><img src = 'images/loading.gif'></img><br>Loading...</div>";
        }            
        else
            System.Gadget.document.getElementById('undockedMapLoading').style.display="block";
            
     //   System.Gadget.document.parentWindow.currentStationMin = tempMax-20;
       // if (System.Gadget.document.parentWindow.currentStationMin < 0) System.Gadget.document.parentWindow.currentStationMin = 0;
       // System.Gadget.document.parentWindow.currentStationMax = tempMax;
       // System.Gadget.document.parentWindow.currentStation = System.Gadget.document.parentWindow.currentStationMin;
        //System.Gadget.document.parentWindow.map.LoadMap(new VELatLong(homeLatLong.Latitude,homeLatLong.Longitude),10,mapMode,false);
        //System.Gadget.document.parentWindow.initMap();
        //System.Gadget.document.parentWindow.isNewMap();
        //if(System.Gadget.document.parentWindow.newMap)
        //    System.Gadget.document.parentWindow.populate();
        //else
        //    System.Gadget.document.parentWindow.populateExisting();
        
            
        if (System.Gadget.Flyout.show){
            System.Gadget.document.parentWindow.currentStationMin = tempMax-20;
            if (System.Gadget.document.parentWindow.currentStationMin < 0) System.Gadget.document.parentWindow.currentStationMin = 0;
            System.Gadget.document.parentWindow.currentStationMax = tempMax;
            System.Gadget.document.parentWindow.currentStation = System.Gadget.document.parentWindow.currentStationMin;
            
            currentStation = System.Gadget.document.parentWindow.currentStation;
            currentStationMax = System.Gadget.document.parentWindow.currentStationMax;
            currentStationMin = System.Gadget.document.parentWindow.currentStationMin;
        }
        else{
            currentStationMin = tempMax-20;
            if (currentStationMin < 0) currentStationMin = 0;
            currentStationMax = tempMax;
            currentStation = currentStationMin;
        }
            
            map.LoadMap(new VELatLong(homeLatLong.Latitude,homeLatLong.Longitude),10,mapMode,false);
            initMap();
            isNewMap();
            if(newMap)
                populate();
            else
                populateExisting();
            
    }
}

///////////////////////////////////////////////////////////////////////////////////////////////////////


function formatMapPlaces(){
    for(i = 0; i < mapPlaces.length; i++){
     //   if (mapPlaces[i] != null && mapPlaces[i]!= '')
     try{
            mapPlaces[i] = new VELatLong(mapPlaces[i].Latitude, mapPlaces[i].Longitude);
            }
     catch(e){
        continue;
        }
    }
}