
///////////////////////////////////////////////////////////////////////////////////////////////////
//
// Global Settings Members
//
///////////////////////////////////////////////////////////////////////////////////////////////////
var req;
var clicked='provstateSelect';
var pageData = '';
var locSite = 'http://www.gasbuddy.com/Gas_Prices/STATEPROV/index.aspx';
var gasSiteFormat = 'SITENAME/index.aspx?s=Y&fuel=FUELTYPE&area=LOCATION&station=All+Stations&tme_limit=84';

/// Global vars to submit for use outside settings
var gasSiteSubmit='';
var mapCenter='';
var mapPC=''; 
var mapAddr='';
var mapStateProv='';
var mapCity='';
var mapMode='';

/// Global vars solely for settings that require reload on settings open
var country='';
var provstate='';
var tempGasSite='';
var cityName='';
var fuelType='';
var location='';


///////////////////////////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////////////////////////
//
// loadSettings - first method called when Settings page loads
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function loadSettings() {   
    // main Setting page onload method (first method called every time the Settings page is loaded)
    
    // init event methods
    System.Gadget.onSettingsClosing = closeSettings;                 // set settings page closing event
    
    // get settings data
    provstate = System.Gadget.Settings.read("provstateEnv");
    tempGasSite = System.Gadget.Settings.read("tempGasSiteEnv");
    fuelType = System.Gadget.Settings.read("fuelTypeEnv");
    location = System.Gadget.Settings.read("locationEnv");
    
    mapMode = System.Gadget.Settings.read("mapModeEnv");
    mapCenter = System.Gadget.Settings.read("mapCenterEnv");
    mapPC = System.Gadget.Settings.read("mapPCEnv");
    mapAddr = System.Gadget.Settings.read("mapAddrEnv");	
    mapStateProv = System.Gadget.Settings.read("mapStateProvEnv");
    mapCity = System.Gadget.Settings.read("mapCityEnv");
        
    // add data to Settings page
    if(provstate != null & provstate != ''){
        document.getElementById('provstateSelect').value = provstate;    
        loadCityData();  
        document.getElementById('citySelect').value = tempGasSite;
        document.getElementById('areaSelect').value = location.replace('+'," ");
        document.getElementById('postalCodeInput').value = mapPC;
        document.getElementById('cityInput').value = mapCity;
        document.getElementById('streetAddrInput').value = mapAddr;
        document.getElementById('stateprovMapSelect').value = mapStateProv;
        
        document.getElementById(mapCenter).checked="true";
        document.getElementById(mapMode).checked="true";
    }
}
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////////////////
//
// closeSettings - process settings page closing event
//
///////////////////////////////////////////////////////////////////////////////////////////////////
function closeSettings(event){
    // process settings page closing event
    if (event.Action.commit != null && event.closeAction == event.Action.commit) {
        // save settings
        if (gasSiteSubmit != null && gasSiteSubmit != ''){
            mapPC = document.getElementById('postalCodeInput').value;
            mapCity = document.getElementById('cityInput').value;
            mapAddr = document.getElementById('streetAddrInput').value;
            mapStateProv = document.getElementById('stateprovMapSelect').value;
            
            System.Gadget.Settings.write("gasSiteEnv", gasSiteSubmit);      
            System.Gadget.Settings.write("mapCenterEnv", mapCenter);
            System.Gadget.Settings.write("mapModeEnv", mapMode);
            System.Gadget.Settings.write("mapPCEnv", mapPC);
            System.Gadget.Settings.write("mapAddrEnv", mapAddr);
            System.Gadget.Settings.write("mapStateProvEnv", mapStateProv);
            System.Gadget.Settings.write("mapCityEnv", mapCity);
            
		    System.Gadget.Settings.write("countryEnv", country);
		    System.Gadget.Settings.write("provstateEnv", provstate);
		    System.Gadget.Settings.write("tempGasSiteEnv", tempGasSite);
		    System.Gadget.Settings.write("cityNameEnv", cityName);
		    System.Gadget.Settings.write("fuelTypeEnv", fuelType);
		    System.Gadget.Settings.write("locationEnv", location);         
    		
		    System.Gadget.Settings.write("newSettingsEnv",'true');
    		
  //  		System.Gadget.document.getElementById('undockedMap').style.display="none";
    		System.Gadget.document.getElementById('undockedMapLoading').style.display="block";
		    System.Gadget.document.getElementById('gadgetNoSettings').innerHTML = "<div style='top:60px; text-align:center; color:white; position:relative'><img src = 'images/loading.gif'></img><br>Loading...</div>";
		    System.Gadget.document.getElementById('undockedMapLoading').innerHTML = "<div style='top:60px; text-align:center; color:white; position:relative'><img src = 'images/loading.gif'></img><br>Loading...</div>";
		}
    }
    else
    {
        if (gasSiteSubmit == null || gasSiteSubmit == '' || !System.Gadget.document.parentWindow.dataLoaded()){
            System.Gadget.document.getElementById('gadgetNoSettings').innerHTML = "<div style='top:50px; text-align:center; color:white; position:relative'>Configure Settings First</div>";
            System.Gadget.document.getElementById('undockedMapLoading').innerHTML = "<div style='top:70px; text-align:center; color:white; position:relative'>Configure Settings First</div>";
        }
        else{
            System.Gadget.document.parentWindow.setItems();
            System.Gadget.document.getElementById('gadgetNoSettings').style.display="none";
		    System.Gadget.document.getElementById('gadgetGasData').style.display="block";
		}
    }
    event.cancel = false;    
}
///////////////////////////////////////////////////////////////////////////////////////////////////

///////////////////////////////////////////////////////////////////////////////////////
//
// loadProvStateData - use country to load provinces
//
//////////////////////////////////////////////////////////////////////////////////////
function loadProvStateData(){
	document.getElementById('cityDiv').innerHTML = '<select disabled><option>Select State/Province</option></select>';
	document.getElementById('areaDiv').innerHTML = '<select disabled><option>Select City</option></select>';
	
	for(i = 0; i<4; i++){
		document.getElementsByName('fuelRadio')[i].disabled="true";
	}

	if (document.getElementsByName('countryRadio')[0].checked == true) country='canada';
	else country = 'us';	

    var tempCountry = System.Gadget.Settings.read("countryEnv");
    if(tempCountry != null && tempCountry != '')
        country = tempCountry;
	
	var provstateDiv = document.getElementById('provstateDiv');
	var stateList = "<select id='provstateSelect' style='font-size:12px;width:auto;' onchange='loadCityData();' onclick='setClicked(\"provstateSelect\");'><option>------------------------</option>" +
					"<option value='alabama'>Alabama</option>" +
					"<option value='alaska'>Alaska</option>" +
					"<option value='arizona'>Arizona</option>" +
					"<option value='arkansas'>Arkansas</option>" +
					"<option value='california'>California</option>" +
					"<option value='colorado'>Colorado</option>" +
					"<option value='connecticut'>Connecticut</option>" +
					"<option value='delaware'>Delaware</option>" +
					"<option value='florida'>Florida</option>" +
					"<option value='georgia'>Georgia</option>" +
					"<option value='hawaii'>Hawaii</option>" +
					"<option value='idaho'>Idaho</option>" +
					"<option value='illinois'>Illinois</option>" +
					"<option value='indiana'>Indiana</option>" +
					"<option value='iowa'>Iowa</option>" +
					"<option value='kansas'>Kansas</option>" +
					"<option value='kentucky'>Kentucky</option>" +
					"<option value='louisiana'>Louisiana</option>" +
					"<option value='maine'>Maine</option>" +
					"<option value='maryland'>Maryland</option>" +
					"<option value='massachusetts'>Massachusetts</option>" +
					"<option value='michigan'>Michigan</option>" +
					"<option value='minnesota'>Minnesota</option>" +
					"<option value='mississippi'>Mississippi</option>" +
					"<option value='missouri'>Missouri</option>" +
					"<option value='montana'>Montana</option>" +
					"<option value='nebraska'>Nebraska</option>" +
					"<option value='nevada'>Nevada</option>" +
					"<option value='new_hampshire'>New Hampshire</option>" +
					"<option value='new_jersey'>New Jersey</option>" +
					"<option value='new_mexico'>New Mexico</option>" +
					"<option value='new_york'>New York</option>" +
					"<option value='north_carolina'>North Carolina</option>" +
					"<option value='north_dakota'>North Dakota</option>" +
					"<option value='ohio'>Ohio</option>" +
					"<option value='oklahoma'>Oklahoma</option>" +
					"<option value='oregon'>Oregon</option>" +
					"<option value='pennsylvania'>Pennsylvania</option>" +
					"<option value='rhode_island'>Rhode Island</option>" +
					"<option value='south_carolina'>South Carolina</option>" +
					"<option value='south_dakota'>South Dakota</option>" +
					"<option value='tennessee'>Tennessee</option>" +
					"<option value='texas'>Texas</option>" +
					"<option value='utah'>Utah</option>" +
					"<option value='vermont'>Vermont</option>" +
					"<option value='virginia'>Virginia</option>" +
					"<option value='washington'>Washington</option>" +
					"<option value='washington_dc'>Washington D.C.</option>" +
					"<option value='west_virginia'>West Virginia</option>" +
					"<option value='wisconsin'>Wisconsin</option>" +
					"<option value='wyoming'>Wyoming</option></select>";

	var provinceList = "<select id='provstateSelect' style='font-size:12px;width:auto;' onchange='loadCityData();' onclick='setClicked(\"provstateSelect\");'><option>-----------------------------</option>" +
			"<option value='alberta'>Alberta</option>" +
			"<option value='british_columbia'>British Columbia</option>" +
			"<option value='manitoba'>Manitoba</option>" +
			"<option value='new_brunswick'>New Brunswick</option>" +
			"<option value='newfoundland'>Newfoundland</option>" +
			"<option value='nova_scotia'>Nova Scotia</option>" +
			"<option value='ontario'>Ontario</option>" +
			"<option value='pei'>Prince Edward Island</option>" +
			"<option value='quebec'>Quebec</option>" +
			"<option value='saskatchewan'>Saskatchewan</option></select>";

	if (country == 'canada')
		provstateDiv.innerHTML = provinceList;
	if (country == 'us')
		provstateDiv.innerHTML = stateList;
}


/////////////////////////////////////////////////////////////////////////////////////
///
/// loadCityData - use province/state info to obtain city info
///
/////////////////////////////////////////////////////////////////////////////////////
function loadCityData(){
	var tempSite;
	var provstateSelect = document.getElementById('provstateSelect');
	provstate = provstateSelect.value;
	

	if(provstate == null || provstate ==''){
		document.getElementById('cityDiv').innerHTML="<select disabled><option>Select Province/State</option></select>";
		document.getElementById('areaDiv').innerHTML = '<select disabled><option>Select City</option></select>';
		for(i = 0; i<4; i++){
			document.getElementsByName('fuelRadio')[i].disabled="true";
		}

	}
	else {
		tempSite = locSite.replace(/STATEPROV/,provstate);
		retrievePageData(tempSite);
		parseCityData();
	}
	
}

//////////////////////////////////////////////////////////////////////////////
///
/// parseCityData - Parses the page source to obtain the cities that are searchable and loads the select tag
///
//////////////////////////////////////////////////////////////////////////////////////
function parseCityData(){
	if(pageData=='' || pageData == null){
		document.getElementById('provstateSelect').disabled="true";
		document.getElementById('cityDiv').innerHTML="<select disabled><option>Loading....</option></select>";
		setTimeout("parseCityData()",250);
	}
	else{
		var parsedPageData = pageData.match(/http.*GasPrices.com.*blank.*Prices/g);
		pageData='';
			
		var cityList = "<select onchange='loadAreaData();' onclick='setClicked(\"citySelect\");' id='citySelect' style='font-size:12px;width:auto;'>";
		
		var lastVal = parsedPageData[0].match(/http.*.com/);
		var lastName = parsedPageData[0].match(/blank.*Gas/);
		
		if(parsedPageData.length > 1){
			for(i =1; i<parsedPageData.length; i++){
				var tempVal = parsedPageData[i].match(/http.*.com/);
				var tempName = parsedPageData[i].match(/blank.*Gas/);
				tempName = tempName[0].substring(6, tempName[0].length - 3);
				
				var tempOption = "<option value='"+tempVal[0]+"'>"+tempName+"</option>";
				cityList += tempOption; 
			}
			lastName = "Rest of " + lastName[0].substring(6, lastName[0].length - 3);
		}
		else {
			lastName = "All of " + lastName[0].substring(6, lastName[0].length - 3);	
		}
		
		
		var lastOption = "<option value='"+lastVal[0]+"'>"+lastName+"</option></select>";
		cityList +=lastOption;
	
		
				
		document.getElementById('cityDiv').innerHTML = cityList;
		loadAreaData();
	}
}

/////////////////////////////////////////////////////////////////////////////////////////
///
/// loadAreaData - Gathers the areas available to search within
///
/////////////////////////////////////////////////////////////////////////////////////////
function loadAreaData(){
	
	tempGasSite = document.getElementById('citySelect').value;
	cityName  = tempGasSite.substring(11, tempGasSite.length - 13).replace(/state/,"");
	retrievePageData(tempGasSite);
	parseAreaData();
}

/////////////////////////////////////////////////////////////////////////////////////////
///
/// parseAreaData - Parses retrieved data for area information
///
/////////////////////////////////////////////////////////////////////////////////////////
function parseAreaData(){
	if(pageData=='' || pageData==null){
		document.getElementById('citySelect').disabled="true";
		document.getElementById('areaDiv').innerHTML="<select disabled><option>Loading...</option></select>";
		setTimeout("parseAreaData()",250);
	}
	else{
		var regEx = new RegExp("PSA_lbArea\">[^$]*.*</select>","i");
		var parsedPageData=pageData.match(regEx);
		pageData='';
		document.getElementById('areaDiv').innerHTML = "<select id='areaSelect' onchange=''>" + parsedPageData;
		document.getElementById('citySelect').disabled="";
		document.getElementById('provstateSelect').disabled="";	
		for(i = 0; i<4; i++){
			document.getElementsByName('fuelRadio')[i].disabled="";
		}	
		document.getElementById(clicked).focus();
		createGasURL();
	}
	
}

/////////////////////////////////////////////////////////////////////////////////////////
///
/// getSelectedFuelType - returns the selected fuel type
///
/////////////////////////////////////////////////////////////////////////////////////////
function getSelectedFuelType(){
	if(document.getElementById('regularRadio').checked==true) return 'A';
	else if(document.getElementById('midRadio').checked==true) return 'B';
	else if(document.getElementById('premiumRadio').checked==true) return 'C';
	else if(document.getElementById('dieselRadio').checked==true) return 'D';
}		

/////////////////////////////////////////////////////////////////////////////////////////
///
/// disableMapStyles - just disables/enables fields as per map style selection 
///
/////////////////////////////////////////////////////////////////////////////////////////
function disableMapStyles(){
		var pcMapRadio = document.getElementById('postalCodeMapRadio');
		var cityMapRadio = document.getElementById('cityMapRadio');
		var addrMapRadio = document.getElementById('addressMapRadio');
		var pcInput = document.getElementById('postalCodeInput');
		var addrInput = document.getElementById('streetAddrInput');
		var stateProvSelect = document.getElementById('stateprovMapSelect');
		var cityInput = document.getElementById('cityInput');
		
		if (cityMapRadio.checked){
			pcInput.disabled = "true";
			addrInput.disabled = "true";
			cityInput.disabled = "true";
			stateProvSelect.disabled = "true";
			mapCenter = "cityMapRadio";
		}
		else if (pcMapRadio.checked){
			pcInput.disabled = "";
			addrInput.disabled = "true";
			cityInput.disabled = "true";
			stateProvSelect.disabled ="true";
			mapCenter = "pcMapRadio";
		}
		else if (addrMapRadio.checked){
			pcInput.disabled = "true";
			addrInput.disabled = "";
			cityInput.disabled = "";
			stateProvSelect.disabled = "";
			mapCenter = "addrMapRadio";
		}
		else if (wifiMapRadio.checked){
		    pcInput.disabled = "true";
			addrInput.disabled="true";
			cityInput.disabled = "true";
			stateProvSelect.disabled = "true";
			mapCenter = "wifiMapRadio";
		}
		
			
	}

/////////////////////////////////////////////////////////////////////////////////////////
///
/// createGasURL - creates the URL to obtain gas info from
///
/////////////////////////////////////////////////////////////////////////////////////////
function createGasURL(){
	fuelType = getSelectedFuelType();
	location = document.getElementById('areaSelect').value.replace(/ /,"+");
	gasSiteSubmit = gasSiteFormat.replace(/SITENAME/, tempGasSite);
	gasSiteSubmit = gasSiteSubmit.replace(/FUELTYPE/, fuelType);
	gasSiteSubmit = gasSiteSubmit.replace(/LOCATION/, location);
	
	var mapStyleRadio = document.getElementById('hybridMapRadio');
	
    if (mapStyleRadio.checked)
        mapMode = "hybridMapRadio";
    else
        mapMode = "roadMapRadio";
		
}

///////////////////////////////////////////////////////////////////////////////////////////////
///
/// setClicked - sets a flag to which list was clicked to retain focus
///
/////////////////////////////////////////////////////////////////////////////////////////////
function setClicked(obj){
	clicked = obj;
}

///////////////////////////////////////////////////////////////////////////////////////////////
///
/// setTab - sets current Tab borders
///
/////////////////////////////////////////////////////////////////////////////////////////////
function setTab(tab){
	if(tab == 'gasTab'){
		gasTab.style.borderLeft='thin gray solid';
		gasTab.style.borderRight='thin gray solid';
		gasTab.style.borderTop='thin gray solid';
		mapTab.style.border='thin gray none';
		gasSettings.style.display='block';
		mapSettings.style.display='none';
	}
	else {
		mapTab.style.borderLeft='thin gray solid';
		mapTab.style.borderRight='thin gray solid';
		mapTab.style.borderTop='thin gray solid';
		gasTab.style.border='thin gray none';
		mapSettings.style.display='block';
		gasSettings.style.display='none';
	}

	
}

 
///////////////////////////////////////////////////////////////////////////////////////////
///
/// retrievePageData(url) - takes a URL to retrieve page data from and calls function to set hidden value to page data
///
//////////////////////////////////////////////////////////////////////////////////////////
function retrievePageData(url){
	req = new ActiveXObject("Microsoft.XMLHTTP");
	if (req) {
		req.onreadystatechange = processStateChange;
		req.open("GET", url, true);
		req.send();
	}
}
 
///////////////////////////////////////////////////////////////////////////////////////////////////////////
///
/// processStateChange - when request receives OK resposne sets the hidden value to the acquired page data
///
///////////////////////////////////////////////////////////////////////////////////////////////////////////
function processStateChange() {
	if (req.readyState == 4) { // Complete
		if (req.status == 200) { // OK response
			pageData = req.responseText;
		}
	}
}